﻿using System.Linq;

namespace HeuristicLab.Problems.ProgramSynthesis.Base.Erc.IntegerVector {
  using HeuristicLab.Common;
  using HeuristicLab.Data;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class IntegerVectorConstantsErc : VectorConstantsErc<int, IntArray> {
    public IntegerVectorConstantsErc() : this(new int[0][]) { }

    public IntegerVectorConstantsErc(params int[][] values) : this(true, 1d, values) { }

    public IntegerVectorConstantsErc(bool isEnabled, double weight = 1d, params int[][] values)
      : base(isEnabled, weight, values.Select(v => new IntArray(v)).ToArray()) {
      Name = "Integer vector constants";
    }

    [StorableConstructor]
    protected IntegerVectorConstantsErc(bool deserializing)
      : base(deserializing) {
    }

    public IntegerVectorConstantsErc(IntegerVectorConstantsErc origin, Cloner cloner)
      : base(origin, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new IntegerVectorConstantsErc(this, cloner);
    }
  }
}
