﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Configuration {
  using System.Collections.Generic;
  using Base.Erc;

  using Stack;

  public interface IReadOnlyPushConfiguration : IReadOnlyExpressionsConfiguration {
    int Seed { get; }
    int EvalPushLimit { get; }
    int MaxDepth { get; }
    int MaxStringLength { get; }
    int MaxVectorLength { get; }
    int MaxPointsInProgram { get; }
    int MaxPointsInRandomExpression { get; }
    bool TopLevelPushCode { get; }
    bool TopLevelPopCode { get; }
    int MaxParenthesesClose { get; }
    double ParenthesesCloseBiasLevel { get; }
    IReadOnlyErcOptions ErcOptions { get; }
    IReadOnlyList<string> EnabledExpressions { get; }
    string FloatStringFormat { get; }

    bool IsStackEnabled(StackTypes stackType);
  }
}
