﻿using System.Collections.Generic;

namespace HeuristicLab.Problems.ProgramSynthesis.Push.Encoding {

  using HeuristicLab.Common;
  using HeuristicLab.Core;
  using HeuristicLab.Optimization;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
  using HeuristicLab.Problems.ProgramSynthesis.Push.SolutionCreator;

  [Item("PlushEncoding", "Describes an linear push (Plush) encoding.")]
  [StorableClass]
  public class PlushEncoding : Encoding<IPlushCreator> {
    public PlushEncoding(bool deserializing)
      : base(deserializing) {
    }

    public PlushEncoding(Encoding<IPlushCreator> original, Cloner cloner)
      : base(original, cloner) {
    }

    public PlushEncoding(string name)
      : base(name) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new PlushEncoding(this, cloner);
    }

    public override void ConfigureOperators(IEnumerable<IOperator> operators) {
      //ConfigureBoundedOperators(operators.OfType<IBoundedIntegerVectorOperator>());
      //ConfigureCreators(operators.OfType<IPlushCreator>());
      //ConfigureCrossovers(operators.OfType<IIntegerVectorCrossover>());
      //ConfigureManipulators(operators.OfType<IIntegerVectorManipulator>());
      //ConfigureShakingOperators(operators.OfType<IIntegerVectorMultiNeighborhoodShakingOperator>());
      //ConfigureStrategyVectorOperator(operators.OfType<IIntegerVectorStdDevStrategyParameterOperator>());
    }

    //private void ConfigureCreators(IEnumerable<IPlushCreator> creators) {
    //  foreach (var creator in creators) {
    //    creator.IntegerVectorParameter.ActualName = Name;
    //    creator.BoundsParameter.ActualName = BoundsParameter.Name;
    //    creator.LengthParameter.ActualName = LengthParameter.Name;
    //  }
    //}
  }
}
