﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Encoding {
  using System.Collections.Generic;

  using HeuristicLab.Common;
  using HeuristicLab.Core;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class PlushVector : Item {

    private List<PlushEntry> entries;

    public PlushVector() : this(0) {

    }

    public PlushVector(int length) {
      entries = new List<PlushEntry>(length);
    }

    [StorableConstructor]
    public PlushVector(bool deserializing) : base(deserializing) {
    }

    public PlushVector(PlushVector origin, Cloner cloner) : base(origin, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new PlushVector(this, cloner);
    }
  }
}
