﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
  using System.Collections.Generic;
  using System.Linq;

  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;

  using Microsoft.VisualStudio.TestTools.UnitTesting;

  [TestClass]
  public class StringVectorExpressionTests : VectorExpressionTests<string> {
    protected override string TypeName { get { return "STRING[]"; } }

    protected override IPushStack<IReadOnlyList<string>> Stack { get { return interpreter.StringVectorStack; } }
    protected override IPushStack<string> LiteralStack { get { return interpreter.StringStack; } }

    protected override IReadOnlyList<string>[] GetValues(int count) {
      return Enumerable
        .Range(0, count)
        .Select(x => GetLiterals(interpreter.Configuration.MaxVectorLength / 2 - 1))
        .ToArray();
    }

    protected override IReadOnlyList<string> GetLiterals(int count) {
      return Enumerable
        .Range(0, count)
        .Select(x => interpreter.Configuration.ErcOptions.StringErcOptions.GetErcValue(interpreter.Random))
        .ToArray();
    }

    protected override void CheckOtherStacksAreEmpty() {
      TestStackCounts(stringVectorStack: null);
    }
  }
}
